﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using Microsoft.Research.Kinect.Audio;
using Microsoft.Speech.Recognition;
using Microsoft.Speech.AudioFormat;
using System.Threading;

namespace depth
{
    class KinectSpeech
    {

        KinectAudioSource audioSource;
        private const string RecognizerId = "SR_MS_en-US_Kinect_10.0";
        SpeechRecognitionEngine sre = null;

        public class SaidSomethingArgs : EventArgs
        {
            public String word { get; set; }
        }


        public event EventHandler<SaidSomethingArgs> SaidSomething;

        public KinectSpeech()
        {
            RecognizerInfo ri = SpeechRecognitionEngine.InstalledRecognizers().Where(r => r.Id == RecognizerId).FirstOrDefault();
            sre = new SpeechRecognitionEngine(ri.Id);
            Choices commands = new Choices();

            commands.Add("play");
            commands.Add("stop");
            commands.Add("switch");
            commands.Add("arran is gay");
            commands.Add("left hand gain");
            commands.Add("left hand synth one gain");

            GrammarBuilder gb = new GrammarBuilder();
            gb.Culture = ri.Culture;
            gb.Append(commands);

            Grammar g = new Grammar(gb);
            sre.LoadGrammar(g);


            sre.SpeechRecognized += SreSpeechRecognized;
            sre.SpeechHypothesized += SreSpeechHypothesized;
            sre.SpeechRecognitionRejected += SreSpeechRecognitionRejected;

            Thread t = new Thread(StartAudio);
            t.Start();
            
        }

        public void StartAudio()
        {
            audioSource = new KinectAudioSource();
            audioSource.FeatureMode = true;
            audioSource.AutomaticGainControl = false;
            audioSource.SystemMode = SystemMode.OptibeamArrayOnly;
            Stream s = audioSource.Start();
            sre.SetInputToAudioStream(s, new SpeechAudioFormatInfo(EncodingFormat.Pcm, 16000, 16, 1, 32000, 2, null));
            sre.RecognizeAsync(RecognizeMode.Multiple);

        }

        public void StopAudio()
        {
            sre.RecognizeAsyncStop();
            audioSource.Dispose();
        }

        void SreSpeechRecognitionRejected(object sender, SpeechRecognitionRejectedEventArgs e)
        {
            Console.WriteLine("\nSpeech Rejected");


        }

        void SreSpeechHypothesized(object sender, SpeechHypothesizedEventArgs e)
        {
            Console.Write("\rSpeech Hypothesized: \t{0}", e.Result.Text);

        }

        void SreSpeechRecognized(object sender, SpeechRecognizedEventArgs e)
        {
            //This first release of the Kinect language pack doesn't have a reliable confidence model, so 
            //we don't use e.Result.Confidence here.
            if (e.Result.Confidence < 0.8)
                return;
            Console.WriteLine("\nSpeech Recognized: \t{0}  \t {1}", e.Result.Text, e.Result.Confidence);
            SaidSomethingArgs said = new SaidSomethingArgs();
            said.word = e.Result.Text;
            SaidSomething(new object(), said);
        }



    }
}
